#ifndef _CAST_HELPER_H_
#define _CAST_HELPER_H_

#include <abstraction/Registry.h>

namespace cli {

class CastHelper {
public:
	static std::shared_ptr < abstraction::OperationAbstraction > castHelper ( const std::shared_ptr < abstraction::OperationAbstraction > & param, const std::string & type ) {
		if ( abstraction::Registry::isCastNoOp ( type, param->getReturnType ( ) ) ) {
			return param;
		}

		bool normalize;

		std::shared_ptr < abstraction::OperationAbstraction > res = abstraction::Registry::getCastAbstraction ( type, param->getReturnType ( ), normalize );
		res->attachInput ( param, 0 );
		res->eval ( );

		if ( normalize ) {
			std::shared_ptr < abstraction::OperationAbstraction > normalized = abstraction::Registry::getNormalizeAbstraction ( res->getReturnType ( ) );
			normalized->attachInput ( res, 0 );
			normalized->eval ( );

			res = normalized;
		}

		return res;
	}

};

} /* namespace cli */

#endif /* _CAST_PARAM_H_ */
